var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { promises as fsPromises } from 'fs';
import matter from 'gray-matter';
function getMainFile(filepath) {
    var filePathArr = filepath.split('/').filter(Boolean);
    if (filePathArr[filePathArr.length - 2] !== 'translations')
        return filepath;
    var basename = filePathArr[filePathArr.length - 3];
    var result = __spreadArray(__spreadArray([], filePathArr.slice(0, filePathArr.length - 2), true), ["".concat(basename, ".mdx")], false).join('/');
    return result;
}
function getMatter(filepath) {
    return __awaiter(this, void 0, void 0, function () {
        var str, e_1, _a, data, content, contentFormatted;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fsPromises.readFile(filepath, 'utf-8')];
                case 1:
                    str = _b.sent();
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _b.sent();
                    str = '';
                    console.error("File does not exist: ".concat(filepath, "."));
                    return [3 /*break*/, 3];
                case 3:
                    _a = matter(str), data = _a.data, content = _a.content;
                    contentFormatted = content;
                    if (contentFormatted) {
                        contentFormatted = contentFormatted.replace(/^\n+/, '').replace(/[ \t]+$/, '');
                    }
                    return [2 /*return*/, {
                            data: data,
                            content: content,
                        }];
            }
        });
    });
}
export function read(filepath) {
    return __awaiter(this, void 0, void 0, function () {
        var mainFile, defaultData, mainFilePath, _a, data, content;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    mainFile = getMainFile(filepath);
                    if (!(mainFile === filepath)) return [3 /*break*/, 1];
                    defaultData = {};
                    return [3 /*break*/, 3];
                case 1:
                    mainFilePath = getMainFile(filepath);
                    return [4 /*yield*/, getMatter(mainFilePath).then(function (r) { return r.data; })];
                case 2:
                    defaultData = _b.sent();
                    _b.label = 3;
                case 3: return [4 /*yield*/, getMatter(filepath)];
                case 4:
                    _a = _b.sent(), data = _a.data, content = _a.content;
                    return [2 /*return*/, { content: content, data: __assign(__assign({}, defaultData), data) }];
            }
        });
    });
}
//# sourceMappingURL=read.js.map