var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import minimist from 'minimist';
import dayjs from 'dayjs';
import fastGlob from 'fast-glob';
import path from 'path';
import getImageSize from 'image-size';
import fs, { promises as fsPromises } from 'fs';
import { getLocalesForFilepath, getPath, getSlugFromPath } from './helpers/path';
import { read } from './helpers/read';
export * from './types';
function getPhoto(photo) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, width, height;
        return __generator(this, function (_b) {
            if (!photo)
                return [2 /*return*/, null];
            try {
                _a = getImageSize(getPath(photo)), width = _a.width, height = _a.height;
                if (!width || !height)
                    throw new Error('No dims!');
                result = { href: photo, w: width, h: height };
            }
            catch (e) {
                console.error(e);
                result = null;
            }
            return [2 /*return*/, result];
        });
    });
}
function getItems(glob, locale, locales) {
    return __awaiter(this, void 0, void 0, function () {
        var result, filepaths, dirnames, i, filepath, dirname, filepathLocale, isCurrentLocale, isFallbackLocale, isRequestedLocalePresent, slug, _a, data, content, fsState, photo, _b, item;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    result = [];
                    filepaths = fastGlob.sync(glob);
                    dirnames = [];
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < filepaths.length)) return [3 /*break*/, 8];
                    filepath = filepaths[i];
                    dirname = path.dirname(filepath);
                    filepathLocale = path.basename(filepath, '.mdx');
                    isCurrentLocale = filepathLocale === locale;
                    isFallbackLocale = filepathLocale === locales[0];
                    if (!isCurrentLocale) {
                        if (!isFallbackLocale)
                            return [3 /*break*/, 7];
                        isRequestedLocalePresent = fs.existsSync(getPath(dirname, "".concat(locale, ".mdx")));
                        if (isRequestedLocalePresent)
                            return [3 /*break*/, 7];
                    }
                    slug = getSlugFromPath(filepath);
                    if (dirnames.includes(dirname)) {
                        return [3 /*break*/, 7];
                    }
                    dirnames = __spreadArray(__spreadArray([], dirnames, true), [dirname], false);
                    return [4 /*yield*/, read(filepath)];
                case 2:
                    _a = _c.sent(), data = _a.data, content = _a.content;
                    return [4 /*yield*/, fsPromises.stat(filepath)];
                case 3:
                    fsState = _c.sent();
                    if (!(typeof data.photo === 'string')) return [3 /*break*/, 5];
                    return [4 /*yield*/, getPhoto(data.photo)];
                case 4:
                    _b = _c.sent();
                    return [3 /*break*/, 6];
                case 5:
                    _b = null;
                    _c.label = 6;
                case 6:
                    photo = _b;
                    console.log('DATA', data.title);
                    item = {
                        data: data,
                        content: content,
                        dateCreated: dayjs(fsState.ctime).toISOString(),
                        dateModified: dayjs(fsState.mtime).toISOString(),
                        filepath: filepath,
                        locales: getLocalesForFilepath(filepath, locales),
                        slug: slug,
                    };
                    if (photo)
                        item.photo = photo;
                    result = __spreadArray(__spreadArray([], result, true), [item], false);
                    _c.label = 7;
                case 7:
                    i += 1;
                    return [3 /*break*/, 1];
                case 8: return [2 /*return*/, result];
            }
        });
    });
}
function run() {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var args, locales, globs, dest, _loop_1, i;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    args = minimist(process.argv.slice(2));
                    locales = (_a = args.locales) === null || _a === void 0 ? void 0 : _a.split(',').map(function (l) { return l.trim(); });
                    if (!locales)
                        throw new Error('Missing locales!');
                    globs = (_b = args.posts) === null || _b === void 0 ? void 0 : _b.split(',').map(function (l) { return l.trim(); });
                    if (!globs)
                        throw new Error('Missing posts!');
                    dest = args.dest;
                    if (!dest)
                        throw new Error('Missing dest!');
                    console.log('⌛ started mdx-db!', args, locales, globs, dest);
                    _loop_1 = function (i) {
                        var items, locale, globI, glob, _d, destPath;
                        return __generator(this, function (_e) {
                            switch (_e.label) {
                                case 0:
                                    items = [];
                                    locale = locales[i];
                                    globI = 0;
                                    _e.label = 1;
                                case 1:
                                    if (!(globI < globs.length)) return [3 /*break*/, 4];
                                    glob = globs[globI];
                                    console.log("|-- doing glob ".concat(glob, "."));
                                    _d = [__spreadArray([], items, true)];
                                    return [4 /*yield*/, getItems(glob, locale, locales)];
                                case 2:
                                    items = __spreadArray.apply(void 0, _d.concat([(_e.sent()), true]));
                                    _e.label = 3;
                                case 3:
                                    globI += 1;
                                    return [3 /*break*/, 1];
                                case 4:
                                    destPath = getPath(dest, "".concat(locale, ".json"));
                                    return [4 /*yield*/, fsPromises.writeFile(destPath, JSON.stringify(items, null, 2)).then(function () {
                                            console.log("".concat(locale, ": ").concat(items.length, " files written."));
                                        })];
                                case 5:
                                    _e.sent();
                                    return [2 /*return*/];
                            }
                        });
                    };
                    i = 0;
                    _c.label = 1;
                case 1:
                    if (!(i < locales.length)) return [3 /*break*/, 4];
                    return [5 /*yield**/, _loop_1(i)];
                case 2:
                    _c.sent();
                    _c.label = 3;
                case 3:
                    i += 1;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
run().catch(function (err) { return console.error(err); });
//# sourceMappingURL=index.js.map